class Fixnum
  def ord() self end
end

def resolution(aviname)
  data = open(aviname, "rb").read(10240)
  pos = data.index('avih')
  w = data[pos+40].ord + (data[pos+41].ord << 8)
  h = data[pos+44].ord + (data[pos+45].ord << 8)
  w = 460 if w < 460
  h = 64 if h < 64
  [w, h]
end

if ARGV.size < 1
  puts "usage: mkpage avifile [suffix]"
  puts "example: mkpage browsing.avi _full"
  exit
end

w, h = resolution(ARGV[0]) 
suffix = ARGV.size > 1 ? ARGV[1] : ""

print <<EOF
<html>
<head>
<title>ScreenPressor web-player alpha</title>
<script language="JavaScript">
<!--
function getFlashMovieObject(movieName)
{
  if (window.document[movieName])   
      return window.document[movieName];  
  if (navigator.appName.indexOf("Microsoft Internet")==-1)
  {
    if (document.embeds && document.embeds[movieName])
      return document.embeds[movieName]; 
  }
  else   
    return document.getElementById(movieName);   	
}	

function play()
{
  getFlashMovieObject("player").spplay();
}

function pause()
{
  getFlashMovieObject("player").sppause();
}

function seek()
{
  getFlashMovieObject("player").spseek(document.forms["controls"]["seekpos"].value);
}

function update_pos()
{
  t = setTimeout("update_pos()", 1000);
  var player = getFlashMovieObject("player");
  if (player==null || player.spposition==null) return;
  document.getElementById("pos").innerHTML = player.spposition().toFixed(2);  
}
t = setTimeout("update_pos()", 1000);
//-->
</script>
</head>
<body bgcolor="#f0f0f0">
This is a demo of Flash-based player for 
<a href="http://www.infognition.com/ScreenPressor/">ScreenPressor</a> lossless video codec.
<p>
<div style="height:#{h}">
 <object classid="clsid:d27cdb6e-ae6d-11cf-96b8-444553540000" id="player" width="#{w}" height="#{h}">
    <param name="movie" value="screenpressor#{suffix}.swf">
    <param name="FlashVars" value="fname=#{ARGV[0]}">
    <param name="allowFullScreen" value="true"/>
    <param name="allowScriptAccess" value="always" />
    <embed type="application/x-shockwave-flash" src="screenpressor#{suffix}.swf"
      width="#{w}" height="#{h}" flashVars="fname=#{ARGV[0]}" 
      allowFullScreen="true" allowScriptAccess="always" name="player">
    </embed>
</object>
</div>
<p>
Controls:
<div style="margin-left:15">
|&lt;  home <br>
&lt;&lt; previous key frame <br>
&lt;| one frame back <br>
&gt;  play <br> 
|&gt; one frame forward <br> 
&gt;&gt; next key frame
</div>
<p>
JavaScript controls:<br>
<form name="controls">
<input type="button" value="Play" onClick="play();">
<input type="button" value="Pause" onClick="pause();">
Position: <b name="pos" id="pos">0.00</b>
<input type="button" value="Seek to" onClick="seek();">
<input type="text" name="seekpos" value="2.5" size="4">
</form>
</body>
</html>
EOF
